



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>block 实现原理详解（一）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">block 实现原理详解（一）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-15 23:50:52 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>对于大多数人来讲，block内部到底是怎样实现的呢？我们可以借助clang将其编译成为c++的代码，就可以看出，block到底是什么东西，</p>
<p>先来看这样一个问题，</p>
<pre class="prettyprint linenums"><code>&lt;!-- lang: cpp --&gt;<br />
        int age = 10;<br />
    void (^block)() = ^{<br />
        NSLog(@"%d",age);<br />
    };<br />
    age  = 30;<br />
    block();//10<br />
</code></pre>
<p>以及下面的这一段代码</p>
<pre class="prettyprint linenums"><code>&lt;!-- lang: cpp --&gt;<br />
        __block int age = 10;<br />
    void (^block)() = ^{<br />
        NSLog(@"%d",age);<br />
    };<br />
    age  = 30;<br />
    block();//30<br />
</code></pre>
<p>你会发现这两个结果是不同的，&nbsp;<br />第一个输出10，第二个输出的是30</p>
<p>要想知道这里面干了些什么！需要我们将其编译成为C++代码，看下里面到底搞了些什么？&nbsp;<br />使用终端，转到mian.m文件下，使用如下代码 clang -rewrite-objc main.m 将其编译生成 main.cpp文件&nbsp;<br />这时候，我们打开mian.cpp便知 在文件的最底下main函数中</p>
<pre class="prettyprint linenums"><code>&lt;!-- lang: cpp --&gt;<br />
int main(int argc, const char * argv[])<br />
</code></pre>
<p>{</p>
<pre class="prettyprint linenums"><code>/* @autoreleasepool */ { __AtAutoreleasePool __autoreleasepool; 

    __attribute__((__blocks__(byref))) __Block_byref_age_0 age = {(void*)0,(__Block_byref_age_0 *)&amp;age, 0, sizeof(__Block_byref_age_0), 10};<br />
    void (*block)() = (void (*)())&amp;__main_block_impl_0((void *)__main_block_func_0, &amp;__main_block_desc_0_DATA, (__Block_byref_age_0 *)&amp;age, 570425344);<br />
    (age.__forwarding-&gt;age) = 30;<br />
    ((void (*)(__block_impl *))((__block_impl *)block)-&gt;FuncPtr)((__block_impl *)block);

}<br />
return 0;<br />
</code></pre>
<p>}</p>
<p>block内部是调用了一个结构体中的函数：&nbsp;<br />static struct&nbsp;<strong>main_block_desc_0 {&nbsp;<br />size_t reserved;&nbsp;<br />size_t Block_size;&nbsp;<br />void (<em>copy)(struct __main_block_impl_0</em>, struct&nbsp;</strong>main_block_impl_0<em>);&nbsp;<br />void (</em>dispose)(struct __main_block_impl_0*);&nbsp;<br />}</p>
<p>然后经过分析该c++文件我们知道&nbsp;<br />block实际上是: 指向结构体的指针&nbsp;<br />编译器会将block的内部代码生成对应的函数</p>
<p>而在mian.m中，调用普通的int变量时，传过来的age其实是一个值传递，而__block则是引用传递！&nbsp;<br />所以，才是如上的结果！</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlmkd19.html">&lbrack;C&rsqb;指针有什么好处&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ex1lxq.html">【代码笔记】iOS-创建具有中划线的文字</a>
		</li>
						<li><a href="https://www.batexi.com/a/495vmzmq.html">eclipse svn快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96vxmv8.html">redis master配置了密码进行主从同步</a>
		</li>
						<li><a href="https://www.batexi.com/a/qderw4v9.html">linux2&period;6中的工作队列接口 workqueue&lowbar;struct</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j03yygq.html">Git本地版本控制备忘</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdv56d9.html">docker 保存 加载（导入 导出镜像</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ko4d59.html">SDVN</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd5m549.html">Windows下createfile函数用GENERIC&lowbar;READ访问模式打不开磁盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2joo0x8.html">tomcat报异常Invalid character found in method name&period; HTTP method names must be tokens</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4ex0e9.html">vue-quill-editor富文本编辑器，上传图片自定义为借口上传</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2dvxx9.html">Daily Scrum 12&period;19</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25x4voq.html">python3基础概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5r6p4q.html">linux 开始</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rxnp39.html">sqlalchemy 和 django 插入操作后自动返回自增ID</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r74pz8.html">电脑用HDMI线分屏后，耳机或音箱没声音之完美解决！</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25pdjlq.html">Flume 高可用配置案例&plus;load balance负载均衡&plus; 案例&colon;日志的采集及汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1mxvlq.html">chattr 改变文件、目录属性 &lpar;chmod、passwd等涉及文件修改的命令提示Operation not permitted&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o607k8.html">使用rsync 同步数据一些常用参数和示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlo2w39.html">判断tableViewCell是否在可视区</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qde05yj9.html">夺命雷公狗---linux之centos的安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydw4ogq.html">Eclipse字符集设置方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydwg4dq.html">selenium 右键另存为操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zm4y69.html">MYSQL 下一些常用操作命令：新建用户、修改密码、修改登录host等</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xrng08.html">freemarker为null处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnw4yz8.html">Linux软件管理&mdash;&mdash;yum命令详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k10d4j9.html">centos查看磁盘扇区大小等信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1exzk9.html">php number&lowbar;format&lpar;&rpar;保留小数点后几位</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm1xn09.html">JavaEE基础（十五）&sol;集合</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xokln9.html">Linux用户组与用户组基本命令</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
